***************************************
* author Brunello Pulix
* Cagliari (Italy)
* brunellopulix@gmail.com
* placed in the public domain
***************************************
*
# include "hmg.ch"
*
# define _CARTELLA  "Cartella N"
# define _CARD      "Card"
*
#translate NTRIM( <v1> ) => ( Ltrim(str(<v1>)) )
*
Request dbfcdx
*
Procedure Main()
  *
  If !File('Temp90.Dbf')
     dbcreate("Temp90",{;
     {'CODICE','C', 3,0},;
     {'NOME'  ,'C',15,0},;
     {'CAMPO1','C',15,0},;
     {'CAMPO2','C',15,0},;
     {'CAMPO3','C',15,0},;
     {'N1'    ,'N', 1,0},;
     {'N2'    ,'N', 1,0},;
     {'N3'    ,'N', 1,0}},"DBFCDX")
     *
  Endif
  Use Temp90 New Exclusive Via 'DBFCDX'
  *
  If !File('Temp75.Dbf')
     dbcreate("Temp75.Dbf",{;
     {'CODICE','C', 3,0},;
     {'NOME'  ,'C',15,0},;
     {'CAMPO1','C',15,0},;
     {'CAMPO2','C',15,0},;
     {'CAMPO3','C',15,0},;
     {'N1'    ,'N', 1,0},;
     {'N2'    ,'N', 1,0},;
     {'N3'    ,'N', 1,0}},"DBFCDX")
     *
  Endif
  Use Temp75 New Exclusive Via 'DBFCDX'
  *
  FV3_OpenMain("Bingo Card Maker",nil,nil,{|| dbCloseAll() })
  FV3_SetValue('nCards',100)
  FV3_SetValue('Check1',.F.)
  *
  FV3_Button('Crea Nuova Base Dati',300,30,{|cWin| NuovaBaseDati()} )
  FV3_SkipRow(35)
  FV3_Label('Numero Cartelle (Max 999)',150)
  FV3_TextBox('nCards',50,'999',1)
  FV3_Label(' ',20)
  FV3_CheckBox('Check1',75,'MultiSelect')
  FV3_SkipRow(30)
  *
  FV3_Button('1-90x9x3)' ,100,30,{|cWin| CreaColonne_90_9(3)   },.T.)
  FV3_Button('1-90x9x4)' ,100,30,{|cWin| CreaColonne_90_9(4)   },.T.)
  FV3_Button('1-90x9x10)',100,30,{|cWin| CreaColonne_90_9_2()  },.T.)
  *
  FV3_SkipRow(35)
  FV3_Button('1-75x9x3)' ,100,30,{|cWin| CreaColonne_75_9(3)  },.T.)
  FV3_Button('1-75x9x4)' ,100,30,{|cWin| CreaColonne_75_9(4)  },.T.)
  FV3_Button('1-75x9x10)',100,30,{|cWin| CreaColonne_75_9_2()},.T.)
  *
  FV3_Show(1)
  *
Return
*
Procedure NuovaBaseDati()
  Local i
  Local aRay    := {}
  Local aCheck  := {}
  Local cString := ''
  *
  If MsgYesNo('Confermi ?')
     dbSelectarea('Temp90')
     zap
     aRay   := {}
     aCheck := {}
     For i := 1 To FV3_GetProperty('nCards','Value')
        cString := CreaDati_90_9()
        If ascan(aCheck,{|n| Check[n] == cString }) == 0
           aadd(aRay,Str(i,3)+'|'+space(15)+cString)
        Endif
     Next
     *
     For i := 1 To Len(aRay)
        a1 := hb_ATokens(aRay[i],'|')
        Temp90->(dbappend())
        Replace Temp90->Codice with a1[1]
        Replace Temp90->Nome   with a1[2]
        Replace Temp90->Campo1 with a1[3]
        Replace Temp90->Campo2 with a1[4]
        Replace Temp90->Campo3 with a1[5]
     Next
     Temp90->(dbgotop())
     *
     dbSelectarea('Temp75')
     Zap
     *
     aRay   := {}
     aCheck := {}
     For i := 1 To FV3_GetProperty('nCards','Value')
        cString := CreaDati_75_9()
        If ascan(aCheck,{|n| Check[n] == cString }) == 0
           aadd(aRay,Str(i,3)+'|'+space(15)+cString)
        Endif
     Next
     *
     For i := 1 To Len(aRay)
        a1 := hb_ATokens(aRay[i],'|')
        Temp75->(dbappend())
        Replace Temp75->Codice with a1[1]
        Replace Temp75->Nome   with a1[2]
        Replace Temp75->Campo1 with a1[3]
        Replace Temp75->Campo2 with a1[4]
        Replace Temp75->Campo3 with a1[5]
     Next
     *
     Temp75->(dbgotop())
     Temp90->(dbgotop())
     *
     Msginfo('OK Nuova Base Dati creata')
     *
  Endif
  *
Return
*
Procedure CreaColonne_90_9(z)
  Local aTable := {}
  Local aTemp  := {}
  Local aRows  := {}
  Local a1     := {}
  Local c1     := ''
  Local n
  Local cRtf   := []
  *
  If z == 3
     cRtf   := [Cartelle_90x9x3.Rtf]
  else
     cRtf   := [Cartelle_90x9x4.Rtf]
  Endif
  *
  aTable := {}
  AAdd(aTable,{100})
  AAdd(aTable,{12,11,11,11,11,11,11,11,11})
  AAdd(aTable,{60,40})
  *
  RTF_OPEN(cRtf,aTable,'P')
  PutHeader(cRtf)
  *PutFooter()
  *
  x := 0
  dbselectarea('Temp90')
  If FV3_GetProperty('Check1','Value')
     aRows := MultiSelect()
  Endif
  aRay  := {}
  Temp90->(dbgotop())
  Do while Temp90->(!Eof())
     If !Empty(aRows)
        if ascan(aRows,{|x| val((alias())->Codice) == x } ) == 0
           (alias())->(dbskip())
           Loop
        Endif
     Endif
     *
     RTF_EMPTYROW()
     *
     ++x
     *
     c1 := RtfStyle(_CARTELLA,"",'0',"70","")
     c1 += RtfStyle('o',"uX",'0',"70","")
     c1 += ' '+RtfStyle(Trim(Temp90->Codice),"b",'0',"80","")
     *
     RTF_WriteRow(3,{;
     MakeCell(c1,"40","l","LTR","",0,"","","",'B15'),;
     MakeCell(Upper(Trim(Temp90->Nome)),"40","l","BTR","i",0,"","","",'B15')})
     *
     a1 := OrdinaColonne_90_9(Temp90->Campo1)
     *
     RTF_WRITEROW(2,{;
     MakeCell(a1[1],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[1]),'A12','')),;
     MakeCell(a1[2],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[2]),'A12','')),;
     MakeCell(a1[3],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[3]),'A12','')),;
     MakeCell(a1[4],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[4]),'A12','')),;
     MakeCell(a1[5],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[5]),'A12','')),;
     MakeCell(a1[6],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[6]),'A12','')),;
     MakeCell(a1[7],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[7]),'A12','')),;
     MakeCell(a1[8],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[8]),'A12','')),;
     MakeCell(a1[9],"70","c","LTR","" ,0,"","",'',IF(Empty(a1[9]),'A12',''))})
     *
     a1 := OrdinaColonne_90_9(Temp90->Campo2)
     *
     RTF_WRITEROW(2,{;
     MakeCell(a1[1],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[1]),'A12','')),;
     MakeCell(a1[2],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[2]),'A12','')),;
     MakeCell(a1[3],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[3]),'A12','')),;
     MakeCell(a1[4],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[4]),'A12','')),;
     MakeCell(a1[5],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[5]),'A12','')),;
     MakeCell(a1[6],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[6]),'A12','')),;
     MakeCell(a1[7],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[7]),'A12','')),;
     MakeCell(a1[8],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[8]),'A12','')),;
     MakeCell(a1[9],"70","c","LTR","" ,0,"","",'',IF(Empty(a1[9]),'A12',''))})
     *
     a1 := OrdinaColonne_90_9(Temp90->Campo3)
     *
     RTF_WRITEROW(2,{;
     MakeCell(a1[1],"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[1]),'A12','')),;
     MakeCell(a1[2],"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[2]),'A12','')),;
     MakeCell(a1[3],"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[3]),'A12','')),;
     MakeCell(a1[4],"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[4]),'A12','')),;
     MakeCell(a1[5],"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[5]),'A12','')),;
     MakeCell(a1[6],"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[6]),'A12','')),;
     MakeCell(a1[7],"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[7]),'A12','')),;
     MakeCell(a1[8],"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[8]),'A12','')),;
     MakeCell(a1[9],"70","c","BLTR","" ,0,"","",'',IF(Empty(a1[9]),'A12',''))})
     *
     If z == 4
        *RTF_EMPTYROW()
     else
        RTF_EMPTYROW()
        RTF_EMPTYROW()
        RTF_EMPTYROW()
        RTF_EMPTYROW()
     Endif
     *
     If x == z
        RTF_NEWSECTION()                              // Word
        *RTF_NEWPAGE('P')   // OpenOffice-LibreOffice
        x := 0
     Endif
     Temp90->(dbskip())
  Enddo
  Temp90->(dbgotop())
  *
  RTF_CLOSE()
  *
  execute file (cRtf)
  *
Return
*
Procedure CreaColonne_90_9_2()
  Local aRay   := {}
  Local aList  := {}
  Local Scelta
  Local aTable := {}
  Local c1     := ''
  Local c2     := ''
  Local a1     := {}
  Local a2     := {}
  Local aFlags := {'','','','','','','','',''}
  Local aTemp1 := {}
  Local aTemp2 := {}
  Local aTemp3 := {}
  Local aTemp4 := {}
  Local aRows  := {}
  Local i
  Local j
  Local n
  Local nBlock
  Local nPage
  Local cRtf   := [Cartelle_90x9x10.Rtf]
  *
  If FV3_GetProperty('Check1','Value')
     aRows := MultiSelect()
  Endif
  aRay  := {}
  Temp90->(dbgotop())
  If Empty(aRows)
     Do while (alias())->(!Eof())
        aadd(aRay,(alias())->Codice+'|'+Padr((alias())->Nome,15)+'|'+(alias())->Campo1+'|'+(alias())->Campo2+'|'+(alias())->Campo3)
        (alias())->(dbskip())
     Enddo
  else
     Do while (alias())->(!Eof())
        if ascan(aRows,val((alias())->Codice)) > 0
           aadd(aRay,(alias())->Codice+'|'+Padr((alias())->Nome,15)+'|'+(alias())->Campo1+'|'+(alias())->Campo2+'|'+(alias())->Campo3)
        endif
        (alias())->(dbskip())
     Enddo
  endif
  *
  Temp90->(dbgotop())
  if Len(aRay) % 2 > 0
     aadd(aRay,[   |               |'' '' '' '' '' |'' '' '' '' '' |'' '' '' '' '' '])
  endif
  *
  aTable := {}
  AAdd(aTable,{100})
  AAdd(aTable,{5,6,5,5,6,5,5,6,5,5,5,6,5,5,6,5,5,6,5})
  AAdd(aTable,{29,19,5,29,19})
  *
  nBlock   := 0
  nPage    := 0
  nTotPage := Len(aRay)/10
  *
  RTF_OPEN(cRtf,aTable,'L',,,{297,210,15,30,10,10})
  PutHeader(cRtf)
  *
  For n := 1 To Len(aRay) step 2
     aTemp1 := {}
     aTemp2 := {}
     aTemp1 := hb_ATokens(aRay[n],'|')
     aadd(aTemp2,aTemp1[1])
     aadd(aTemp2,aTemp1[2])
     aadd(aTemp2,aTemp1[3])
     aadd(aTemp2,aTemp1[4])
     aadd(aTemp2,aTemp1[5])
     *
     aTemp3 := {}
     aTemp4 := {}
     aTemp3 := hb_ATokens(aRay[n+1],'|')
     aadd(aTemp4,aTemp3[1])
     aadd(aTemp4,aTemp3[2])
     aadd(aTemp4,aTemp3[3])
     aadd(aTemp4,aTemp3[4])
     aadd(aTemp4,aTemp3[5])
     *
     RTF_EMPTYROW()
     For i := 1 To 1
        *
        c1 := RtfStyle(_CARTELLA,"",'0',"35","")
        c1 += RtfStyle('o',"uX",'0',"35","")
        c1 += ' '+RtfStyle(aTemp2[1],"b",'0',"40","")
        *
        c2 := RtfStyle(_CARTELLA,"",'0',"35","")
        c2 += RtfStyle('o',"uX",'0',"35","")
        c2 += ' '+RtfStyle(aTemp4[1],"b",'0',"40","")
        *
        RTF_WriteRow(3,{;
        MakeCell(c1,"20","l","LTR","" ,0,"","","",'B15'),;
        MakeCell('',"20","l","BTR","i",0,"","","",'B15'),;
        MakeCell('',"20","l",   "", "",0,"","","",''),;
        MakeCell(c2,"20","l","LTR", "",0,"","","",'B15'),;
        MakeCell('',"20","l","BTR","i",0,"","","",'B15')})
        *
        a1 := OrdinaColonne_90_9(aTemp2[3])
        a2 := OrdinaColonne_90_9(aTemp4[3])
        *
        RTF_WRITEROW(2,{;
        MakeCell(a1[1],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[1]),'A12','')),;
        MakeCell(a1[2],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[2]),'A12','')),;
        MakeCell(a1[3],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[3]),'A12','')),;
        MakeCell(a1[4],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[4]),'A12','')),;
        MakeCell(a1[5],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[5]),'A12','')),;
        MakeCell(a1[6],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[6]),'A12','')),;
        MakeCell(a1[7],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[7]),'A12','')),;
        MakeCell(a1[8],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[8]),'A12','')),;
        MakeCell(a1[9],"35","c","LTR","" ,0,"","",'',IF(Empty(a1[9]),'A12','')),;
        MakeCell(''   ,"10","c",""   ,"" ,0,"","","",''),;
        MakeCell(a2[1],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[1]),'A12','')),;
        MakeCell(a2[2],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[2]),'A12','')),;
        MakeCell(a2[3],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[3]),'A12','')),;
        MakeCell(a2[4],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[4]),'A12','')),;
        MakeCell(a2[5],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[5]),'A12','')),;
        MakeCell(a2[6],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[6]),'A12','')),;
        MakeCell(a2[7],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[7]),'A12','')),;
        MakeCell(a2[8],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[8]),'A12','')),;
        MakeCell(a2[9],"35","c","LTR","" ,0,"","",'',IF(Empty(a2[9]),'A12',''))})
        *
        a1 := OrdinaColonne_90_9(aTemp2[4])
        a2 := OrdinaColonne_90_9(aTemp4[4])
        *
        RTF_WRITEROW(2,{;
        MakeCell(a1[1],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[1]),'A12','')),;
        MakeCell(a1[2],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[2]),'A12','')),;
        MakeCell(a1[3],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[3]),'A12','')),;
        MakeCell(a1[4],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[4]),'A12','')),;
        MakeCell(a1[5],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[5]),'A12','')),;
        MakeCell(a1[6],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[6]),'A12','')),;
        MakeCell(a1[7],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[7]),'A12','')),;
        MakeCell(a1[8],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[8]),'A12','')),;
        MakeCell(a1[9],"35","c","LTR","" ,0,"","",'',IF(Empty(a1[9]),'A12','')),;
        MakeCell(''   ,"10","c",""   ,"" ,0,"","","",''),;
        MakeCell(a2[1],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[1]),'A12','')),;
        MakeCell(a2[2],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[2]),'A12','')),;
        MakeCell(a2[3],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[3]),'A12','')),;
        MakeCell(a2[4],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[4]),'A12','')),;
        MakeCell(a2[5],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[5]),'A12','')),;
        MakeCell(a2[6],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[6]),'A12','')),;
        MakeCell(a2[7],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[7]),'A12','')),;
        MakeCell(a2[8],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[8]),'A12','')),;
        MakeCell(a2[9],"35","c","LTR","" ,0,"","",'',IF(Empty(a2[9]),'A12',''))})
        *
        a1 := OrdinaColonne_90_9(aTemp2[5])
        a2 := OrdinaColonne_90_9(aTemp4[5])
        *
        RTF_WRITEROW(2,{;
        MakeCell(a1[1],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[1]),'A12','')),;
        MakeCell(a1[2],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[2]),'A12','')),;
        MakeCell(a1[3],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[3]),'A12','')),;
        MakeCell(a1[4],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[4]),'A12','')),;
        MakeCell(a1[5],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[5]),'A12','')),;
        MakeCell(a1[6],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[6]),'A12','')),;
        MakeCell(a1[7],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[7]),'A12','')),;
        MakeCell(a1[8],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[8]),'A12','')),;
        MakeCell(a1[9],"35","c","LTBR" ,"" ,0,"","",'',IF(Empty(a1[9]),'A12','')),;
        MakeCell(''   ,"10","c",""    ,"" ,0,"","","",''),;
        MakeCell(a2[1],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[1]),'A12','')),;
        MakeCell(a2[2],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[2]),'A12','')),;
        MakeCell(a2[3],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[3]),'A12','')),;
        MakeCell(a2[4],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[4]),'A12','')),;
        MakeCell(a2[5],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[5]),'A12','')),;
        MakeCell(a2[6],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[6]),'A12','')),;
        MakeCell(a2[7],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[7]),'A12','')),;
        MakeCell(a2[8],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[8]),'A12','')),;
        MakeCell(a2[9],"35","c","LTBR","" ,0,"","",'',IF(Empty(a2[9]),'A12',''))})
        *
        *
        ++nBlock
        *
     Next
     If nBlock == 5
        ++nPage
        If nPage == int(Len(aRay)/10)
           exit
        else
           RTF_NEWSECTION()                            // Word
           *RTF_NEWPAGE('P')   // OpenOffice-LibreOffice
        Endif
        nBlock := 0
     Endif
  Next
  *
  RTF_CLOSE()
  *
  execute file (cRtf)
  *
Return
*
Procedure CreaColonne_75_9(z)
  Local aTable := {}
  Local aTemp  := {}
  Local aRows  := {}
  Local a1     := {}
  Local c1     := ''
  Local c2     := ''
  Local n
  Local cRtf   := ''
  *
  If z == 3
     cRtf := [Cartelle_75x9x3.Rtf]
  else
     cRtf := [Cartelle_75x9x4.Rtf]
  Endif
  *
  aTable := {}
  AAdd(aTable,{100})
  AAdd(aTable,{12,11,11,11,11,11,11,11,11})
  AAdd(aTable,{60,40})
  *
  RTF_OPEN(cRtf,aTable,'P')
  PutHeader(cRtf)
  *PutFooter()
  *
  x := 0
  dbselectarea('Temp75')
  If FV3_GetProperty('Check1','Value')
     aRows := MultiSelect()
  Endif
  Temp75->(dbgotop())
  *
  Do while Temp75->(!Eof())
     *
     If !Empty(aRows)
        if ascan(aRows,{|x| val((alias())->Codice) == x } ) == 0
           (alias())->(dbskip())
           Loop
        Endif
     Endif
     *
     RTF_EMPTYROW()
     *
     ++x
     *
     c1 := RtfStyle(_CARTELLA,"",'0',"70","")
     c1 += RtfStyle('o',"uX",'0',"70","")
     c1 += ' '+RtfStyle(Trim(Temp75->Codice),"b",'0',"80","")
     *
     RTF_WriteRow(3,{;
     MakeCell(c1,"40","l","LTR","",0,"","","",'B15'),;
     MakeCell(Upper(Trim(Temp75->Nome)),"40","l","BTR","i",0,"","","",'B15')})
     *
     a1 := OrdinaColonne_75_9(Temp75->Campo1)
     *
     RTF_WRITEROW(2,{;
     MakeCell(a1[1]  ,"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[1]) ,'A12','')),;
     MakeCell(a1[2]  ,"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[2]) ,'A12','')),;
     MakeCell(a1[3]  ,"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[3]) ,'A12','')),;
     MakeCell(a1[4]  ,"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[4]) ,'A12','')),;
     MakeCell(a1[5]  ,"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[5]) ,'A12','')),;
     MakeCell(a1[6]  ,"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[6]) ,'A12','')),;
     MakeCell(a1[7]  ,"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[7]) ,'A12','')),;
     MakeCell(a1[8]  ,"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[8]) ,'A12','')),;
     MakeCell(a1[9]  ,"70","c","LTR","" ,0,"","",'',IF(Empty(a1[9]) ,'A12',''))})
     *
     a1 := OrdinaColonne_75_9(Temp75->Campo2)
     *
     RTF_WRITEROW(2,{;
     MakeCell(a1[1]  ,"70","c","LT"  ,"" ,0,"","",'',IF(Empty(a1[1])  ,'A12' ,'')),;
     MakeCell(a1[2]  ,"70","c","LT"  ,"" ,0,"","",'',IF(Empty(a1[2])  ,'A12' ,'')),;
     MakeCell(a1[3]  ,"70","c","LT"  ,"" ,0,"","",'',IF(Empty(a1[3])  ,'A12' ,'')),;
     MakeCell(a1[4]  ,"70","c","LT"  ,"" ,0,"","",'',IF(Empty(a1[4])  ,'A12' ,'')),;
     MakeCell(a1[5]  ,"70","c","LT"  ,"" ,0,"","",'',IF(Empty(a1[5])  ,'A12' ,'')),;
     MakeCell(a1[6]  ,"70","c","LT"  ,"" ,0,"","",'',IF(Empty(a1[6])  ,'A12' ,'')),;
     MakeCell(a1[7]  ,"70","c","LT"  ,"" ,0,"","",'',IF(Empty(a1[7])  ,'A12' ,'')),;
     MakeCell(a1[8]  ,"70","c","LT"  ,"" ,0,"","",'',IF(Empty(a1[8])  ,'A12' ,'')),;
     MakeCell(a1[9]  ,"70","c","LTR" ,"" ,0,"","",'',IF(Empty(a1[9])  ,'A12' ,''))})
     *
     a1 := OrdinaColonne_75_9(Temp75->Campo3)
     *
     RTF_WRITEROW(2,{;
     MakeCell(a1[1]  ,"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[1]),'A12','')),;
     MakeCell(a1[2]  ,"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[2]),'A12','')),;
     MakeCell(a1[3]  ,"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[3]),'A12','')),;
     MakeCell(a1[4]  ,"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[4]),'A12','')),;
     MakeCell(a1[5]  ,"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[5]),'A12','')),;
     MakeCell(a1[6]  ,"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[6]),'A12','')),;
     MakeCell(a1[7]  ,"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[7]),'A12','')),;
     MakeCell(a1[8]  ,"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[8]),'A12','')),;
     MakeCell(a1[9]  ,"70","c","BLTR","" ,0,"","",'',IF(Empty(a1[9]),'A12',''))})
     *
     If z == 4
        *RTF_EMPTYROW()
     else
        RTF_EMPTYROW()
        RTF_EMPTYROW()
        RTF_EMPTYROW()
        RTF_EMPTYROW()
     Endif
     *
     If x == z
        RTF_NEWSECTION()                              // Word
        *RTF_NEWPAGE('P')   // OpenOffice-LibreOffice
        x := 0
     Endif
     Temp75->(dbskip())
  Enddo
  Temp75->(dbgotop())
  *
  RTF_CLOSE()
  *
  execute file (cRtf)
  *
Return
*
*
Procedure PutHeader(c)
  *
  c += " -  by brunellopulix@gmail.com - (Italy)"
  RTF_OpenHeader('')
  RTF_WriteRow(1,{MakeCell(c,"22","c","B","bi",0,"","","")})
  RTF_CloseTag()
  *
Return
*
Procedure PutFooter()
  *
  RTF_OpenFooter('')
  RTF_WriteRow(1,{MakeCell("by brunellopulix@gmail.com - (Italy)","22","c","T","ib",0,"","","")})
  RTF_CloseTag()
  *
Return
*
Procedure AKill( a, n )
  ASize( ADel( a, n ), Len( a ) - 1 )
Return
*
Procedure CreaColonne_75_9_2()
  Local aRay   := {}
  Local aList  := {}
  Local Scelta
  Local aTable := {}
  Local c1     := ''
  Local c2     := ''
  Local a1     := {}
  Local a2     := {}
  Local aFlags := {'','','','','','','','',''}
  Local aTemp1 := {}
  Local aTemp2 := {}
  Local aTemp3 := {}
  Local aTemp4 := {}
  Local i
  Local j
  Local n
  Local nBlock
  Local nPage
  Local cRtf   := [Cartelle_75x9x10.Rtf]
  Local aRows  := {}
  *
  If FV3_GetProperty('Check1','Value')
     aRows := MultiSelect()
  Endif
  aRay  := {}
  Temp90->(dbgotop())
  If Empty(aRows)
     Do while (alias())->(!Eof())
        aadd(aRay,(alias())->Codice+'|'+Padr((alias())->Nome,15)+'|'+(alias())->Campo1+'|'+(alias())->Campo2+'|'+(alias())->Campo3)
        (alias())->(dbskip())
     Enddo
  else
     Do while (alias())->(!Eof())
        if ascan(aRows,val((alias())->Codice)) > 0
           aadd(aRay,(alias())->Codice+'|'+Padr((alias())->Nome,15)+'|'+(alias())->Campo1+'|'+(alias())->Campo2+'|'+(alias())->Campo3)
        endif
        (alias())->(dbskip())
     Enddo
  endif
  *
  Temp75->(dbgotop())
  if Len(aRay) % 2 > 0
     aadd(aRay,[   |               |'' '' '' '' '' |'' '' '' '' '' |'' '' '' '' '' '])
  endif
  *
  aTable := {}
  AAdd(aTable,{100})
  AAdd(aTable,{5,6,5,5,6,5,5,6,5,5,5,6,5,5,6,5,5,6,5})
  AAdd(aTable,{29,19,5,29,19})
  *
  nBlock   := 0
  nPage    := 0
  nTotPage := Len(aRay)/10
  *
  RTF_OPEN(cRtf,aTable,'L',,,{297,210,15,30,10,10})
  PutHeader(cRtf)
  *
  For n := 1 To Len(aRay) step 2
     aTemp1 := {}
     aTemp2 := {}
     aTemp1 := hb_ATokens(aRay[n],'|')
     aadd(aTemp2,aTemp1[1])
     aadd(aTemp2,aTemp1[2])
     aadd(aTemp2,aTemp1[3])
     aadd(aTemp2,aTemp1[4])
     aadd(aTemp2,aTemp1[5])
     *
     aTemp3 := {}
     aTemp4 := {}
     aTemp3 := hb_ATokens(aRay[n+1],'|')
     aadd(aTemp4,aTemp3[1])
     aadd(aTemp4,aTemp3[2])
     aadd(aTemp4,aTemp3[3])
     aadd(aTemp4,aTemp3[4])
     aadd(aTemp4,aTemp3[5])
     *
     RTF_EMPTYROW()
     For i := 1 To 1
        *
        c1 := RtfStyle(_CARTELLA,"",'0',"35","")
        c1 += RtfStyle('o',"uX",'0',"35","")
        c1 += ' '+RtfStyle(aTemp2[1],"b",'0',"40","")
        *
        c2 := RtfStyle(_CARTELLA,"",'0',"35","")
        c2 += RtfStyle('o',"uX",'0',"35","")
        c2 += ' '+RtfStyle(aTemp4[1],"b",'0',"40","")
        *
        RTF_WriteRow(3,{;
        MakeCell(c1,"20","l","LTR","" ,0,"","","",'B15'),;
        MakeCell('',"20","l","BTR","i",0,"","","",'B15'),;
        MakeCell('',"20","l",   "", "",0,"","","",''),;
        MakeCell(c2,"20","l","LTR", "",0,"","","",'B15'),;
        MakeCell('',"20","l","BTR","i",0,"","","",'B15')})
        *
        a1 := OrdinaColonne_75_9(aTemp2[3])
        a2 := OrdinaColonne_75_9(aTemp4[3])
        *
        RTF_WRITEROW(2,{;
        MakeCell(a1[1],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[1]),'A12','')),;
        MakeCell(a1[2],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[2]),'A12','')),;
        MakeCell(a1[3],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[3]),'A12','')),;
        MakeCell(a1[4],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[4]),'A12','')),;
        MakeCell(a1[5],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[5]),'A12','')),;
        MakeCell(a1[6],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[6]),'A12','')),;
        MakeCell(a1[7],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[7]),'A12','')),;
        MakeCell(a1[8],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[8]),'A12','')),;
        MakeCell(a1[9],"35","c","LTR","" ,0,"","",'',IF(Empty(a1[9]),'A12','')),;
        MakeCell(''   ,"10","c",""   ,"" ,0,"","","",''),;
        MakeCell(a2[1],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[1]),'A12','')),;
        MakeCell(a2[2],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[2]),'A12','')),;
        MakeCell(a2[3],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[3]),'A12','')),;
        MakeCell(a2[4],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[4]),'A12','')),;
        MakeCell(a2[5],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[5]),'A12','')),;
        MakeCell(a2[6],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[6]),'A12','')),;
        MakeCell(a2[7],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[7]),'A12','')),;
        MakeCell(a2[8],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[8]),'A12','')),;
        MakeCell(a2[9],"35","c","LTR","" ,0,"","",'',IF(Empty(a2[9]),'A12',''))})
        *
        a1 := OrdinaColonne_75_9(aTemp2[4])
        a2 := OrdinaColonne_75_9(aTemp4[4])
        *
        RTF_WRITEROW(2,{;
        MakeCell(a1[1],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[1]),'A12','')),;
        MakeCell(a1[2],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[2]),'A12','')),;
        MakeCell(a1[3],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[3]),'A12','')),;
        MakeCell(a1[4],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[4]),'A12','')),;
        MakeCell(a1[5],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[5]),'A12','')),;
        MakeCell(a1[6],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[6]),'A12','')),;
        MakeCell(a1[7],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[7]),'A12','')),;
        MakeCell(a1[8],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[8]),'A12','')),;
        MakeCell(a1[9],"35","c","LTR","" ,0,"","",'',IF(Empty(a1[9]),'A12','')),;
        MakeCell(''   ,"10","c",""   ,"" ,0,"","","",''),;
        MakeCell(a2[1],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[1]),'A12','')),;
        MakeCell(a2[2],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[2]),'A12','')),;
        MakeCell(a2[3],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[3]),'A12','')),;
        MakeCell(a2[4],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[4]),'A12','')),;
        MakeCell(a2[5],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[5]),'A12','')),;
        MakeCell(a2[6],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[6]),'A12','')),;
        MakeCell(a2[7],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[7]),'A12','')),;
        MakeCell(a2[8],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[8]),'A12','')),;
        MakeCell(a2[9],"35","c","LTR","" ,0,"","",'',IF(Empty(a2[9]),'A12',''))})
        *
        a1 := OrdinaColonne_75_9(aTemp2[5])
        a2 := OrdinaColonne_75_9(aTemp4[5])
        *
        RTF_WRITEROW(2,{;
        MakeCell(a1[1],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[1]),'A12','')),;
        MakeCell(a1[2],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[2]),'A12','')),;
        MakeCell(a1[3],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[3]),'A12','')),;
        MakeCell(a1[4],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[4]),'A12','')),;
        MakeCell(a1[5],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[5]),'A12','')),;
        MakeCell(a1[6],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[6]),'A12','')),;
        MakeCell(a1[7],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[7]),'A12','')),;
        MakeCell(a1[8],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[8]),'A12','')),;
        MakeCell(a1[9],"35","c","LTBR","" ,0,"","",'',IF(Empty(a1[9]),'A12','')),;
        MakeCell(''   ,"10","c",""    ,"" ,0,"","","",''),;
        MakeCell(a2[1],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[1]),'A12','')),;
        MakeCell(a2[2],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[2]),'A12','')),;
        MakeCell(a2[3],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[3]),'A12','')),;
        MakeCell(a2[4],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[4]),'A12','')),;
        MakeCell(a2[5],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[5]),'A12','')),;
        MakeCell(a2[6],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[6]),'A12','')),;
        MakeCell(a2[7],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[7]),'A12','')),;
        MakeCell(a2[8],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[8]),'A12','')),;
        MakeCell(a2[9],"35","c","LTBR","" ,0,"","",'',IF(Empty(a2[9]),'A12',''))})
        *
        *
        ++nBlock
        *
     Next
     If nBlock == 5
        ++nPage
        If nPage == int(Len(aRay)/10)
           exit
        else
           RTF_NEWSECTION()                            // Word
           *RTF_NEWPAGE('P')   // OpenOffice-LibreOffice
        Endif
        nBlock := 0
     Endif
  Next
  *
  RTF_CLOSE()
  *
  execute file (cRtf)
  *
Return
*
Function OrdinaColonne_90_9(c1)
  Local a1,a2
  Local x1,x2,x3,x4,x5,x6,x7,x8,x9
  *
  a2      :=   {'','','','','','','','',''}
  *
  a1      :=   array(5)
  a1[1]   :=   Trim(Substr(c1,1,3))
  a1[2]   :=   Trim(Substr(c1,4,3))
  a1[3]   :=   Trim(Substr(c1,7,3))
  a1[4]   :=   Trim(Substr(c1,10,3))
  a1[5]   :=   Trim(Substr(c1,13,3))
  *
  x1 := [01 02 03 04 05 06 07 08 09]
  x2 := [10 11 12 13 14 15 16 17 18 19]
  x3 := [20 21 22 23 24 25 26 27 28 29]
  x4 := [30 31 32 33 34 35 36 37 38 39]
  x5 := [40 41 42 43 44 45 46 47 48 49]
  x6 := [50 51 52 53 54 55 56 57 58 59]
  x7 := [60 61 62 63 64 65 66 67 68 69]
  x8 := [70 71 72 73 74 75 76 77 78 79]
  x9 := [80 81 82 83 84 85 86 87 88 89 90]
  For i   :=   1 To Len(a1)
     If a1[i] $     x1
        a2[1] := a1[1]
     elseIf a1[i] $ x2
        a2[2] := a1[i]
     elseIf a1[i] $ x3
        a2[3] := a1[i]
     elseIf a1[i] $ x4
        a2[4] := a1[i]
     elseIf a1[i] $ x5
        a2[5] := a1[i]
     elseIf a1[i] $ x6
        a2[6] := a1[i]
     elseIf a1[i] $ x7
        a2[7] := a1[i]
     elseIf a1[i] $ x8
        a2[8] := a1[i]
     elseIf a1[i] $ x9
        a2[9] := a1[i]
     Endif
  Next
  *
Return a2
*
Function OrdinaColonne_75_9(c1)
  Local a1,a2,i
  Local x1,x2,x3,x4,x5,x6,x7,x8,x9
  *
  a2 := {'','','','','','','','',''}
  *
  a1      :=   array(5)
  a1[1]   :=   Trim(Substr(c1,1,3))
  a1[2]   :=   Trim(Substr(c1,4,3))
  a1[3]   :=   Trim(Substr(c1,7,3))
  a1[4]   :=   Trim(Substr(c1,10,3))
  a1[5]   :=   Trim(Substr(c1,13,3))
  *
  *
  x1 := [01 02 03 04 05 06 07]
  x2 := [08 09 10 11 12 13 14 15]
  x3 := [16 17 18 19 20 21 22 23 24 25]
  x4 := [26 27 28 29 30 31 32 33 34 35]
  x5 := [36 37 38 39 40 41 42 43]
  x6 := [44 45 46 47 48 49 50]
  x7 := [51 52 53 54 55 56 57 58 59 60]
  x8 := [61 62 63 64 65 66 67 68 69 70]
  x9 := [71 72 73 74 75]
  *
  For i   :=   1 To Len(a1)
     *
     If a1[i] $     x1
        a2[1] := a1[1]
     elseIf a1[i] $ x2
        a2[2] := a1[i]
     elseIf a1[i] $ x3
        a2[3] := a1[i]
     elseIf a1[i] $ x4
        a2[4] := a1[i]
     elseIf a1[i] $ x5
        a2[5] := a1[i]
     elseIf a1[i] $ x6
        a2[6] := a1[i]
     elseIf a1[i] $ x7
        a2[7] := a1[i]
     elseIf a1[i] $ x8
        a2[8] := a1[i]
     elseIf a1[i] $ x9
        a2[9] := a1[i]
     Endif
     *
  Next
  *
Return a2
*
Procedure CreaDati_75_9()
  Local aLista    := {}
  Local aEstratti := {}
  Local aCol      := {}
  Local i
  Local h
  Local c1
  Local c2
  *
  For i := 1 To 75
     aadd(aEstratti,i)
  Next
  *
  c1 := ''
  For h := 1 To 3
     aCol := {}
     If h == 1
        XYZ(01,08,@aLista,aEstratti,@aCol)
        XYZ(17,24,@aLista,aEstratti,@aCol)
        XYZ(33,40,@aLista,aEstratti,@aCol)
        XYZ(49,56,@aLista,aEstratti,@aCol)
        XYZ(65,72,@aLista,aEstratti,@aCol)
     elseif h == 2
        XYZ(08,16,@aLista,aEstratti,@aCol)
        XYZ(25,32,@aLista,aEstratti,@aCol)
        XYZ(41,48,@aLista,aEstratti,@aCol)
        XYZ(57,64,@aLista,aEstratti,@aCol)
        XYZ(71,75,@aLista,aEstratti,@aCol)
     else
        XYZ(01,07,@aLista,aEstratti,@aCol)
        XYZ(21,25,@aLista,aEstratti,@aCol)
        XYZ(26,35,@aLista,aEstratti,@aCol)
        XYZ(44,50,@aLista,aEstratti,@aCol)
        XYZ(71,75,@aLista,aEstratti,@aCol)
     Endif
     asort(aCol,,,{|x,y| x < y })
     *
     c1 += '|'
     For i := 1 To Len(aCol)
        c1 += Strzero(aCol[i],2)+' '
     Next
     aCol := {}
  Next
  *
Return c1
*
Function XYZ(n1,n2,aLista,aEstratti,aCol)
  Local nReturn
  Local Num
  *
  Do while .T.
     Num := hb_RandomInt(n1,n2)
     if ascan(aLista,Num) == 0
        aadd(aLista,Num)
        nReturn := Num
        exit
     endif
  Enddo
  aadd(aCol,Num)
  *
Return
*
Procedure CreaDati_90_9()
  Local aLista := {}
  Local aEstratti := {}
  Local aEsclusi  := {}
  Local aCol      := {}
  Local i
  Local n
  Local h
  Local c1
  Local c2
  *
  For i := 1 To 90
     aadd(aEstratti,i)
  Next
  *
  c1 := ''
  For h := 1 To 3
     aCol := {}
     *
     If h == 1
        XYZ(01,09,@aLista,aEstratti,@aCol)
        XYZ(20,29,@aLista,aEstratti,@aCol)
        XYZ(40,49,@aLista,aEstratti,@aCol)
        XYZ(60,69,@aLista,aEstratti,@aCol)
        XYZ(70,79,@aLista,aEstratti,@aCol)
     elseif h == 2
        XYZ(10,19,@aLista,aEstratti,@aCol)
        XYZ(30,39,@aLista,aEstratti,@aCol)
        XYZ(50,59,@aLista,aEstratti,@aCol)
        XYZ(70,79,@aLista,aEstratti,@aCol)
        XYZ(80,85,@aLista,aEstratti,@aCol)
     else
        XYZ(01,09,@aLista,aEstratti,@aCol)
        XYZ(20,29,@aLista,aEstratti,@aCol)
        XYZ(40,49,@aLista,aEstratti,@aCol)
        XYZ(60,69,@aLista,aEstratti,@aCol)
        XYZ(85,90,@aLista,aEstratti,@aCol)
     Endif
     asort(aCol,,,{|x,y| x < y })
     *
     c1 += '|'
     For i := 1 To Len(aCol)
        c1 += Strzero(aCol[i],2)+' '
     Next
     *
     aCol := {}
     *
  Next
  *
Return c1
*
Procedure MultiSelect()
  Local aRay := {}
  Local Temp := {}
  Local cRet := ''
  *
  FV3_OpenModal('Caption')
  FV3_SetValue('cText','1+2+3+4+5')
  *
  FV3_TextBox('cText',220,nil,,,,,,,,)
  FV3_SkipRow(30)
  FV3_Label('Es.Type 1+2+15+28+30......',220)
  *
  FV3_Show(2)
  *
  aRay := {}
  If FV3_Result()
     cRet  := FV3_GetValue('cText')
     aTemp := hb_aTokens(Trim(cRet),'+')
     If !Empty(aTemp)
        aeval(aTemp,{|x| aadd(aRay,Val(x)) })
     Endif
  Endif
  *
Return aRay
*
*
